execute if score #TestStart function_run_count matches 0.. run scoreboard players add osp:powers/energy-infusion/upgrades/ench_buff function_run_count 1

## Random Enchantment Buff
# Costs: 96
# Type: Infinite Uses
# Works On: Anything Enchanted
# Description: A random enchantment will be improved by 1 level. Every enchantment has its own limit, 
# and they are often beyond normal enchantment limits. If it selects a enchantment at its limit, it does nothing.

# minecraft:protection: Limit of 10-
# minecraft:fire_protection: Limit of 10-
# minecraft:feather_falling: Limit of 10-
# minecraft:blast_protection: Limit of 10-
# minecraft:projectile_protection: Limit of 10-
# minecraft:respiration: Limit of 10-
# minecraft:aqua_affinity: Limit of 1-
# minecraft:thorns: Limit of 5-
# minecraft:depth_strider: Limit of 5
# minecraft:frost_walker: Limit of 3
# minecraft:binding_curse: Limit of 1
# minecraft:soul_speed: Limit of 5
# minecraft:swift_sneak: Limit of 5
# minecraft:sharpness: Limit of X
# minecraft:smite: Limit of X
# minecraft:bane_of_arthropods: Limit of X
# minecraft:knockback: Limit of 5
# minecraft:fire_aspect: Limit of 5
# minecraft:looting: Limit of 5
# minecraft:sweeping: Limit of 5
# minecraft:efficiency: Limit of 10
# minecraft:silk_touch: Limit of 1
# minecraft:unbreaking: Limit of 10(When hit 10, make tool unbreakable)
# minecraft:fortune: Limit of 5
# minecraft:power: Limit of X
# minecraft:punch: Limit of 5
# minecraft:flame: Limit of 1
# minecraft:infinity: Limit of 1
# minecraft:luck_of_the_sea: Limit of 5
# minecraft:lure: Limit of 5
# minecraft:loyalty: Limit of 10
# minecraft:impaling: Limit of 10
# minecraft:riptide: Limit of 10
# minecraft:channeling: Limit of 1
# minecraft:multishot: Limit of 1
# minecraft:quick_charge: Limit of 5
# minecraft:piercing: Limit of 10
# minecraft:mending: Limit of 1
# minecraft:vanishing_curse: Limit of 1
# origins:water_protection: Limit of 10

scoreboard players remove Energy1 num 96
execute if score Energy1. num matches ..-1 run scoreboard players remove Energy1 num 1
execute if score Energy1. num matches ..-1 run scoreboard players add Energy1. num 9

# Select a Random Enchantment
execute store result score Count num run data get entity @s SelectedItem.tag.Enchantments
execute store result score EnchantmentSel num run data get entity @e[sort=random,limit=1] UUID[0]
execute if score EnchantmentSel num matches ..-1 run scoreboard players operation EnchantmentSel num *= -1 num
scoreboard players operation Temp num = EnchantmentSel num
scoreboard players operation Temp num %= 10 num

scoreboard players operation EnchantmentSel num %= Count num
scoreboard players operation EnchantmentSel num += 1 num

data modify storage osp:osp temp.energyinfusionB set from entity @s SelectedItem.tag.Enchantments

# Upgrade the enchantment
# cycle ench
scoreboard players operation temp num = EnchantmentSel num
#tellraw @a ["",{"text":"= First Cycle Enchants =","color":"gold"},{"text":"\n"},{"text":"temp","color":"#4EC9B0"},{"text":" num","color":"#9CDCFE"},{"text":" = "},{"score":{"name":"temp","objective":"num"}},{"text":"\n"},{"text":"EnchantmentSel","color":"#4EC9B0"},{"text":" num","color":"#9CDCFE"},{"text":" = "},{"score":{"name":"EnchantmentSel","objective":"num"}},{"text":"\n"},{"text":"Count","color":"#4EC9B0"},{"text":" num","color":"#9CDCFE"},{"text":" = "},{"score":{"name":"Count","objective":"num"}}]
#tellraw @a ["",{"text":"Imput: ","color":"#4EC9B0"},{"nbt":"temp.energyinfusionB","storage":"osp:osp","interpret":false}]

execute if score temp num matches 1.. run function osp:powers/energy-infusion/upgrades/ench_buff/cycle_ench
#tellraw @a ["",{"text":"Output: ","color":"#4EC9B0"},{"nbt":"temp.energyinfusionB","storage":"osp:osp","interpret":false}]
#tellraw @a ["",{"text":""}]

# Add 1
execute store result score temp num run data get storage osp:osp temp.energyinfusionB[0].lvl
scoreboard players add temp num 1
execute store result storage osp:osp temp.energyinfusionB[0].lvl short 1 run scoreboard players get temp num

# decycle ench
scoreboard players operation temp num = Count num
scoreboard players operation temp num -= EnchantmentSel num
#tellraw @a ["",{"text":"= Second Cycle Enchants =","color":"gold"},{"text":"\n"},{"text":"temp","color":"#4EC9B0"},{"text":" num","color":"#9CDCFE"},{"text":" = "},{"score":{"name":"temp","objective":"num"}},{"text":"\n"},{"text":"EnchantmentSel","color":"#4EC9B0"},{"text":" num","color":"#9CDCFE"},{"text":" = "},{"score":{"name":"EnchantmentSel","objective":"num"}},{"text":"\n"},{"text":"Count","color":"#4EC9B0"},{"text":" num","color":"#9CDCFE"},{"text":" = "},{"score":{"name":"Count","objective":"num"}}]
#tellraw @a ["",{"text":"Imput: ","color":"#4EC9B0"},{"nbt":"temp.energyinfusionB","storage":"osp:osp","interpret":false}]

execute if score temp num matches 1.. run function osp:powers/energy-infusion/upgrades/ench_buff/cycle_ench
#tellraw @a ["",{"text":"\nOutput: ","color":"#4EC9B0"},{"nbt":"temp.energyinfusionB","storage":"osp:osp","interpret":false}]
#tellraw @a ["",{"text":""}]
#tellraw @a ["",{"text":""}]
#tellraw @a ["",{"text":""}]

# Reset the randomizer, and apply the effect
item modify entity @s weapon.mainhand osp:energy-infusion/upgrades/buff_ench/end
execute if data storage osp:osp temp.energyinfusionB[{id:"minecraft:unbreaking",lvl:10s}] run item modify entity @s weapon.mainhand osp:energy-infusion/upgrades/buff_ench/unbreakable


execute store result storage osp:osp energy-infusion.energy int 1 run scoreboard players get Energy1 num
execute store result storage osp:osp energy-infusion.energyP int 1 run scoreboard players get Energy1. num
item modify entity @s weapon.mainhand osp:energy-infusion/charge
